import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
import { WriteToBufferArgs } from '../types/WriteToBufferArgs';
export type WriteToBufferInstructionArgs = {
    writeToBufferArgs: WriteToBufferArgs;
};
export declare const WriteToBufferStruct: beet.FixableBeetArgsStruct<WriteToBufferInstructionArgs & {
    instructionDiscriminator: number;
}>;
export type WriteToBufferInstructionAccounts = {
    payer: web3.PublicKey;
    bufferPda: web3.PublicKey;
    systemProgram?: web3.PublicKey;
};
export declare const writeToBufferInstructionDiscriminator = 2;
export declare function createWriteToBufferInstruction(accounts: WriteToBufferInstructionAccounts, args: WriteToBufferInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
